aboutsummaryrefslogtreecommitdiffstats
path: root/tests/db-exclusive-lock
diff options
context:
space:
mode:
authorGuilhem Moulin <guilhem@fripost.org>2019-11-09 03:13:45 +0100
committerGuilhem Moulin <guilhem@fripost.org>2019-11-13 06:23:56 +0100
commit67440844c422ee30b31df9a46a7f99ac0e833add (patch)
tree989381e5b94d5939dafdd1e99c7db2ada95355ec /tests/db-exclusive-lock
parentb9da6cc7ecf71026d1023dc3354b820c7518426e (diff)
Refactor and improve test suite.
Diffstat (limited to 'tests/db-exclusive-lock')
-rw-r--r--tests/db-exclusive-lock/t16
1 files changed, 16 insertions, 0 deletions
diff --git a/tests/db-exclusive-lock/t b/tests/db-exclusive-lock/t
new file mode 100644
index 0000000..88172c9
--- /dev/null
+++ b/tests/db-exclusive-lock/t
@@ -0,0 +1,16 @@
+interimap_init
+
+# start a background process
+interimap --watch=60 &
+trap "ptree_abort $!" EXIT INT TERM
+
+# wait a short while so we have time to lock the database (ugly and racy...)
+sleep .5
+
+# subsequent runs fail as we can't acquire the exclusive lock
+! interimap || error
+
+grep -Fx "DBD::SQLite::db do failed: database is locked at ./interimap line 177." <"$STDERR" \
+ || error "Is \$DBH->do(\"PRAGMA locking_mode = EXCLUSIVE\"); at line 177?"
+
+# vim: set filetype=sh :